; GUI #
include win64a.inc
; --------------- 
WINDOWWIDTH  = 656
WINDOWHEIGHT = 518
xrot	equ rot
yrot	equ rot+4
zrot	equ rot+8
xspeed	equ speed
yspeed	equ speed+4
zspeed	equ speed+4
VERTEX	struct;   .      
;x, y  z    .  x, y  z  
	x dd ?
	y dd ?
	z dd ?
VERTEX	ends
OBJECT	struct;  
	verts dd ? ; verts   ,  
;     
	points dd ?; points      
;VERTEX( x, y  z).       x, y 
; z   ,   points[{,    
; }].{x, y  z}
OBJECT	ends
.code
WinMain	proc
local	msg:MSG

	xor	ebx,ebx
        mov	edi,offset szClassName
        mov	esi,IMAGE_BASE
        mov	ecx,offset FileName
	invoke	LoadCursorFromFile
        push	rax	;hIconSm
	push	rdi	;lpszClassName
	push	rbx	;lpszMenuName
	push	COLOR_WINDOWTEXT+1;hbrBackground
	push	rax	;hCursor
	push	rax        ;hIcon
	push	rsi	;hInstance
	push	rbx        ;cbClsExtra & cbWndExtra
	pushaddr WndProc;lpfnWndProc
	mov	rax,(CS_HREDRAW or CS_VREDRAW or CS_OWNDC)shl 32 \
	or (sizeof WNDCLASSEX)
	push	rax	;cbSize & style
    	invoke	RegisterClassEx,esp	;addr WNDCLASSEX
	
	push	rbx
	push	rsi	;rsi = 400000h
	shl	esi,9	;rsi = CW_USEDEFAULT
	push	rbx
	push	rbx
	push	WINDOWHEIGHT
	push	WINDOWWIDTH
	push	rsi
	push	rsi
	sub	esp,20h
    	invoke	CreateWindowEx,0,edi,edi,WS_OVERLAPPEDWINDOW or \
	WS_CLIPCHILDREN or WS_CLIPSIBLINGS or WS_VISIBLE
; 
    	lea	edi,msg
@@:	invoke	GetMessage,edi,0,0,0	
	invoke	DispatchMessage,edi
	jmp	@b
WinMain endp
WndProc	proc	hWin:QWORD,uMsg:QWORD,wParam:QWORD,lParam:QWORD
local	ps:PAINTSTRUCT
local	w:dword
local	h:dword
local	tmp:dword
local	q:VERTEX
local	tx:dword
local	ty:dword
local	tz:dword

        mov	hWin,rcx
	xor	ebx,ebx

        cmp	edx,WM_CREATE
	je      wmCREATE
        cmp	edx,WM_SIZE
	je      wmSIZE
        cmp	edx,WM_PAINT
	je      wmPAINT
	cmp	edx,WM_TIMER
	je	wmTIMER
        cmp	edx,WM_DESTROY
	je      wmDESTROY
        cmp	edx,WM_KEYDOWN
	je      wmKEYDOWN          
default:leave
	jmp	NtdllDefWindowProc_
wmDESTROY:invoke wglMakeCurrent,0,0
	invoke	wglDeleteContext,hRC
	invoke	ReleaseDC,hWin,hDC
        invoke	KillTimer,hWin,10
	mov	ecx,offset morph1
        invoke	objfree;jump to code to release morph1 allocated ram
	mov	ecx,offset morph2
        invoke	objfree;jump to code to release morph2 allocated ram
	mov	ecx,offset morph3
        invoke	objfree;jump to code to release morph3 allocated ram
	mov	ecx,offset morph4
        invoke	objfree;jump to code to release morph4 allocated ram
	mov	ecx,offset helper
        invoke	objfree;jump to code to release helper allocated ram
	invoke	RtlExitUserProcess,NULL
;------------------------------
wmTIMER:movaps	xmm0,rot
	addps	xmm0,speed
	movaps	rot,xmm0;xrot+=xspeed; 
        invoke	InvalidateRect,,0,0
	jmp	wmBYE
wmKEYDOWN:mov	al,r8b;wParam
	cmp	al,VK_1;31h
	jb	@5
	cmp	al,VK_4;34h
	ja	@6
	cmp	morph,TRUE
	je	wmBYE
	dec	eax
	and	eax,3
	cmp	al,key
	je	wmBYE
	mov	key,al
	mov	morph,TRUE
	mov	eax,morph0[rax*4]
	mov	dest,eax;offset morph1 
	jmp	@0
@5:	cmp	al,VK_ESCAPE;user press 'Esc'? 1Bh
	je	wmDESTROY
	cmp	al,VK_PRIOR;21h
	jne	@f
	movss	xmm0,zspeed
	addss	xmm0,const0_01
	movss	zspeed,xmm0
	jmp	@0
@@:	cmp	al,VK_NEXT;22h
	jne	@f
	movss	xmm0,zspeed
	subss	xmm0,const0_01
	movss	zspeed,xmm0
	jmp	@0
@@:	cmp	al,VK_LEFT;25h
	jne	@f
	movss	xmm0,yspeed
	subss	xmm0,const0_01
	movss	yspeed,xmm0
	jmp	@0
@@:	cmp	al,VK_UP;26h
	jne	@f
	movss	xmm0,xspeed
	subss	xmm0,const0_01
	movss	xspeed,xmm0
	jmp	@0
@@:	cmp	al,VK_RIGHT;27h
	jne	@f
	movss	xmm0,yspeed
	addss	xmm0,const0_01
	movss	yspeed,xmm0
	jmp	@0
@@:	cmp	al,VK_DOWN;28h
	jne	wmBYE
	movss	xmm0,xspeed
	addss	xmm0,const0_01
	movss	xspeed,xmm0
	jmp	@0
@6:	cmp	al,VK_A;41h
	jne	@f
	movss	xmm0,cx_
	subss	xmm0,const0_01
	movss	cx_,xmm0
	jmp	@0
@@:	cmp	al,VK_D;44h
	jne	@f
	movss	xmm0,cx_
	addss	xmm0,const0_01
	movss	cx_,xmm0
	jmp	@0
@@:	cmp	al,VK_Q;51h
	jne	@f
	movss	xmm0,cz
	subss	xmm0,const0_01
	movss	cz,xmm0
	jmp	@0
@@:	cmp	al,VK_S;53h
	jne	@f
	movss	xmm0,cy
	subss	xmm0,const0_01
	movss	cy,xmm0
	jmp	@0
@@:	cmp	al,VK_W;57h
	jne	@f
	movss	xmm0,cy
	addss	xmm0,const0_01
	movss	cy,xmm0
	jmp	@0
@@:	cmp	al,VK_Z;5Ah
	jne	wmBYE
	movss	xmm0,cz
	addss	xmm0,const0_01
	movss	cz,xmm0
@0:	invoke	InvalidateRect,,0,0
        jmp	wmBYE
;-----------------------------------------	
wmCREATE:invoke	GetDC ;  
	mov	hDC,rax
;    OpenGL ( OpenGL   
;)  
        mov	edx,offset PixFrm
	invoke	ChoosePixelFormat,eax
;  
	mov	r8d,offset PixFrm
	invoke	SetPixelFormat,hDC,eax
;     OpenGL
	invoke	wglCreateContext,hDC
	mov	hRC,rax
;   
	invoke	wglMakeCurrent,hDC,eax
	invoke	SetTimer,hWin,10,25,0;  #10  25mSec
;-------------------------------------------------------
;    .     
;     
	invoke	glBlendFunc,GL_SRC_ALPHA,GL_ONE; Set The Blending Function For Translucency
	xorps	xmm3,xmm3
	xorps	xmm2,xmm2
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glClearColor;(0.0f, 0.0f, 0.0f, 0.0f);// This Will Clear The Background Color To Black
        cvtss2sd xmm0,const1
	invoke	glClearDepth;(1.0);		 Enables Clearing Of The Depth Buffer
	invoke	glDepthFunc,GL_LESS;		 The Type Of Depth Test To Do
	invoke	glEnable,GL_DEPTH_TEST;	 Enables Depth Testing
	invoke	glShadeModel,GL_SMOOTH;	 Enables Smooth Color Shading
	invoke	glHint,GL_PERSPECTIVE_CORRECTION_HINT,GL_NICEST; Really Nice Perspective Calculations
;  maxver  0.    ,   
;     .     
;    .    .    
;   sphere.txt.     ,  
; morph1.         morph2  morph3. 
	and	maxver,0;		 Sets Max Vertices To 0 By Default
	mov	edx,offset morph1
	mov	ecx,offset spheretxt
	invoke	objload; Load The First Object Into morph1 From File sphere.txt
	mov	edx,offset morph2
	mov	ecx,offset torustxt
	invoke	objload; Load The Second Object Into morph2 From File torus.txt
	mov	edx,offset morph3
	mov	ecx,offset tubetxt
	invoke	objload; Load The Third Object Into morph3 From File tube.txt
;     .   ,  
;  .      ,   
;   ,   objallocate(&morph4, 486). 
; 486  ,         
; 486  (   ,     
; )
	mov	ecx,offset morph4
	invoke	objallocate,,486;	 Manually Reserver Ram For A 4th 468 Vertice Object (morph4)
;     ,     
;x, y  z  .       
;  -7  7. (14000/1000=14...  7     
;+7...     0,     0-7  -7).
	mov	edi,dword ptr morph4.points;for(int i=0;i<486;i++)		 Loop Through All 468 Vertices
	mov	tmp,edi
	add	tmp,486*12;5832=16C8h
	invoke	GetTickCount
	invoke	srand,eax;	 Try To Get More Randomness
@@:	mov	esi,3
@2:	invoke	rand
	cdq
	mov	ecx,14000
	idiv	ecx
	cvtsi2ss xmm0,edx
	mulss	xmm0,const0_001
	subss	xmm0,const7
;	morph4.points[i].x=((float)(rand()%14000)/1000)-7; morph4 x Point Becomes A Random Float Value From -7 to 7
	movd	eax,xmm0
	stosd
	dec	esi
	jnz	@2
	cmp	edi,tmp
	jb	@b
; sphere.txt    helper.     
;    morph{1/2/3/4} .   
; ,   helper,       4 
;.     morph1 (),    
; helper    .  
; ,    ,     
; (sour  dest)   morph1,   . 
; ,     .
; sphere.txt  helper (   )
	mov	edx,offset helper 
	mov	ecx,offset spheretxt
	invoke	objload; Load sphere.txt Object Into Helper (Used As Starting Point)
;Source & Destination Are Set To Equal First Object (morph1)
;	mov	dest,offset morph1.verts
;	mov	sour,offset morph1.verts
	mov	r9d,(WINDOWHEIGHT shl 16)or WINDOWWIDTH 
wmSIZE:; --------------- Resize the scene
	movzx	r8,r9w
	mov	w,r8d
	shr	r9d,16
	mov	h,r9d
	invoke	glViewport,0,0;     
        invoke	glMatrixMode,GL_PROJECTION;     
	invoke	glLoadIdentity;		   
;    , ..    (  glcall ..     8 )
	movq	xmm3,constd100
	movq	xmm2,constd0_1
	cvtsi2sd xmm1,w
	cvtsi2sd xmm0,h
	divsd	xmm1,xmm0
	movq	xmm0,constd45
	invoke	gluPerspective
;    
	invoke	glMatrixMode,GL_MODELVIEW;     ()
	invoke	glLoadIdentity		;   
        jmp	wmBYE
wmPAINT:; No pending messages: draw the scene
	lea	edx,ps
	invoke  BeginPaint
; --------------- Display the scene
;    ,    .  
;   ,  ,    
;cx, cy  cz.
; ,   xrot, yrot  zrot.
;     xpseed, yspeed  zspeed.
;    tx, ty  tz     q.
;  
	invoke	glClear,GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT; Clear The Screen And The Depth Buffer
	invoke	glLoadIdentity;	 Reset The View
	movss	xmm2,cz
	movss	xmm1,cy
	movss	xmm0,cx_
	invoke	glTranslatef;(cx_,cy,cz);		 Translate The The Current Position To Start Drawing
	xorps	xmm3,xmm3
	xorps	xmm2,xmm2
	movss	xmm1,const1
	movss	xmm0,xrot
	invoke	glRotatef;(xrot,1,0,0);		 Rotate On The X Axis By xrot
	xorps	xmm3,xmm3
	movss	xmm2,const1
	xorps	xmm1,xmm1
	movss	xmm0,yrot
	invoke	glRotatef;(yrot,0,1,0);		 Rotate On The Y Axis By yrot
	movss	xmm3,const1
	xorps	xmm2,xmm2
	xorps	xmm1,xmm1
	movss	xmm0,zrot
	invoke	glRotatef;(zrot,0,0,1);		 Rotate On The Z Axis By zrot
;  ,   ,   .  
;glBegin(GL_POINTS)  OpenGL,   ,   , 
;     .
;      .    
;maxver, ,        , 
;  morph1.verts.
;  ,    morph TRUE.  ,   
;    (i).     q.x, q.y  q.z. 
; ,  q.x, q.y  q.z    0 ( ).
;  helper    ,   
;calculate(i) (,    ,     
; 0.1 ,  ,    40  20  200 ).
;      x, y  z,    
;   helper.
;   helper   tx, ty  tz 
;(t{x/y/z}=helper.points[i].{x/y/z}).
	invoke	glBegin,GL_POINTS; Begin Drawing Points
	xor	esi,esi
@4:     cmp     morph,FALSE
	jz	@f
	lea	ecx,q
	invoke	calculate
	jmp	@3
@@:     mov	q.VERTEX.x,ebx
	mov	q.VERTEX.y,ebx
	mov	q.VERTEX.z,ebx
@3:;	The Same Amount Of Verts For Simplicity, Could Use maxver Also)
;q.x=q.y=q.z=0;	// If morph Is True Calculate Movement Otherwise Movement=0
	movss	xmm2,const1
	movss	xmm1,xmm2
	xorps	xmm0,xmm0
	invoke	glColor3f;(0,1,1);	 Set Color To A Bright Shade Of Off Blue
        mov	eax,helper.points
	movss	xmm0,dword ptr [rax+rsi].VERTEX.x
	subss	xmm0,q.VERTEX.x
	movss	tx,xmm0
        movss	dword ptr [rax+rsi].VERTEX.x,xmm0

	movss	xmm1,dword ptr [rax+rsi].VERTEX.y
	subss	xmm1,q.VERTEX.y
	movss	ty,xmm1
        movss	dword ptr [rax+rsi].VERTEX.y,xmm1

	movss	xmm2,dword ptr [rax+rsi].VERTEX.z
	subss	xmm2,q.VERTEX.z
	movss	tz,xmm2
        movss	dword ptr [rax+rsi].VERTEX.z,xmm2
	invoke	glVertex3f;(tx,ty,tz); Draw A Point At The Current Temp Values (Vertex)
	movss	xmm2,const1
	movss	xmm1,const0_5
	xorps	xmm0,xmm0
	invoke	glColor3f;(0,0.5f,1); Darken Color A Bit
	movss	xmm0,tx
	subss	xmm0,q.VERTEX.x
	movss	tx,xmm0
	movss	xmm1,ty
	subss	xmm1,q.VERTEX.y
	movss	ty,xmm1
	movss	xmm2,tz
	subss	xmm2,q.VERTEX.z
	movss	xmm2,tz
	invoke	glVertex3f;(tx,ty,tz); Draw A Second Point At The Newly Calculate Position
	movss	xmm2,const1
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glColor3f;(0,0,1);	 Set Color To A Very Dark Blue
	movss	xmm0,tx
	subss	xmm0,q.VERTEX.x
	movss	xmm1,ty
	subss	xmm1,q.VERTEX.y
	movss	xmm2,tz
	subss	xmm2,q.VERTEX.z
	invoke	glVertex3f;(tx,ty,tz); Draw A Third Point At The Second New Position
	add	esi,12
	cmp	esi,486*12;morph.verts*12
	jb	@4
	invoke	glEnd;	 Done Drawing Points
	cmp	morph, 0
	jz	@f
	mov	al, step
	cmp	al, steps
	ja	@f
	inc	step
	jmp	@1
; ---------------------------------------------------------------------------
@@:	mov	morph,FALSE
	mov	edx, dest
	mov	sour, edx
	and	step,0
; If We're Morphing And We Haven't Gone Through All 200 Steps Increase Our Step Counter
; Otherwise Set Morphing To False, Make Source=Destination And Set The Step Counter Back To Zero.

;   
@1:     invoke	SwapBuffers,hDC
        lea	edx,ps
	invoke  EndPaint,hWin
wmBYE:	leave
	retn
WndProc	endp
;    ,  .   
; k.  free()     , 
; ,        (k)
objfree proc k:OBJECT; Frees The Object (Releasing The Memory)
	mov	eax,dword ptr k
	mov	ecx,[rax].OBJECT.points
	invoke	GlobalFree; Frees Points
	leave
	retn
objfree endp
;   . *name -   . *k   , 
;     .
;      ver.  ver    
;,    .
;  rx, ry  rz    x, y  z  .
; filein      ,  
;oneline[]     255  .
;       (  CTRL-Z  
; ).    ,  readstr(filein, oneline). 
;      oneline.
; ,   ,    (oneline)     
;"Vertices: {- }{\n}".   ,     
; ver.     ,   
; .        , 
;  ,    : Vertices: {- }.
;,      ,     
; verts .      , 
;   verts  .
;,             . 
;   objallocate({ }, { })
objload proc FileName:dword,k:OBJECT
local	temp:dword
local	filein:dword
local	ver:dword
local	rx:dword
local	ry:dword
local	rz:dword
local	oneline[256]:byte
local	buffser[100h]:byte

	mov	dword ptr k,edx
	mov	edx,offset aRt
	invoke	fopen
        mov	filein,eax
	lea	edx,oneline
	invoke	readstr,eax
	lea	r8d,ver
	mov	edx,offset aVerticesD ; "Vertices: %d\n"
	lea	ecx,oneline		; char *
	invoke	sscanf
	mov	edx,ver
	mov	edi,dword ptr k
	mov	[rdi].OBJECT.verts,edx;k->verts=ver; Sets Objects verts Variable To Equal The Value Of ver
	imul	eax,edx,sizeof VERTEX
	mov	temp,eax

	invoke	objallocate,edi
	mov	edi,[rdi].OBJECT.points
	add	temp,edi
@@:	lea	edx,oneline		; char *
	mov	ecx,filein
	invoke	readstr
	lea	eax,rz
	mov	[rsp+20h],rax
	lea	r9d,ry
	lea	r8d,rx
	mov	edx,offset aFFF	; "%f %f %f"
	lea	ecx,oneline
	invoke	sscanf
;   ,        
; ver,   maxver.  ver  maxver,    
;maxver  ver.  ,     ,   
;20 ,  maxver   20. ,     , 
;  40 ,  maxver   40.  ,  , 
;      .
;  points.x  (k)  rx
	mov	eax,rx
	stosd;k->points[i].x = rx; Sets Objects (k) points.x Value To rx
	mov	eax,ry
	stosd;k->points[i].y = ry; Sets Objects (k) points.y Value To ry
	mov	eax,rz
	stosd;k->points[i].z = rz; Sets Objects (k) points.z Value To rz
	cmp	edi,temp
	jb	@b
exit0:	mov	ecx,filein
	invoke	fclose; 
;      
; ver   maxver,  maxver  ver
	mov	eax,ver
	cmp	eax,maxver
	jbe	@f
	mov	maxver, eax
@@:	leave
	retn
objload endp
;    points  k.    
;    VERTEX (3   float)   
;  (n). ,    10  (n=10),     
;  30   (3   float * 10 )
objallocate proc k:OBJECT,n:dword
;        k->points=(VERTEX*)malloc(sizeof(VERTEX)*n); Sets points Equal To VERTEX * Number Of Vertices
	mov	dword ptr k,ecx
	imul	eax,edx,sizeof VERTEX;eax=n*12
	invoke	GlobalAlloc,GMEM_ZEROINIT or GMEM_FIXED,eax
	mov	ecx,dword ptr k
	mov	[rcx].OBJECT.points,eax
	leave
	retn
objallocate endp
;     ,   .  
;    i.     
;  VERTEX.      
;   a  VERTEX,      a   
;  x, y  z.
;    .  x  a  
;  x  sour->points[i].x -  
;dest->points[i].x -,   steps.  
;    - .   x  
;-  40,   x -  20. 
; ,  steps  200!  a.x=(40-20)/200=(20)/200=0.1 
; ,      40   20  200 ,   
;  0.1    .     0.1 
; 200,    20. 40-20=20
;        ,    
;    y  z,   .     
;steps,       (),    
;      .  
; This Makes Points Move At A Speed So They All Get To Their
;    .      
;  *f.       string.
;   do-while .  fgets()  255   
;  f      *string.     
;(  \n),        . 
; while()    , ,   ,  
; .         
; ,    ,   .

calculate proc x0:dword;,i:dword;(int i) Calculates Movement Of Points During Morphing

	mov	x0,ecx
	movzx	ecx,steps
	cvtsi2ss xmm1,ecx;st(0)=steps

	mov	edx,sour
	mov	edx,[rdx].OBJECT.points;edx=sour->points
	movss	xmm0,dword ptr [rdx+rsi].VERTEX.x;sour->points[i].x
	mov	ecx,dest
	mov	ecx,[rcx].OBJECT.points;eax=dest->points
	subss	xmm0,dword ptr [rcx+rsi].VERTEX.x;dest->points[i].x
	divss	xmm0,xmm1
	mov	eax,x0
	movss	dword ptr [rax].VERTEX.x,xmm0
	movss	xmm0,dword ptr [rdx+rsi].VERTEX.y;sour->points[i].y
	subss	xmm0,dword ptr [rcx+rsi].VERTEX.y;dest->points[i].y
	divss	xmm0,xmm1
	movss	dword ptr [rax].VERTEX.y,xmm0
	movss	xmm0,dword ptr [rdx+rsi].VERTEX.z;sour->points[i].y
	subss	xmm0,dword ptr [rcx+rsi].VERTEX.z;dest->points[i].y
	divss	xmm0,xmm1
	movss	dword ptr [rax].VERTEX.z,xmm0
	mov	eax,x0
	leave
	ret
calculate endp; this makes points move at a speed so they all get to the i
readstr proc filein:dword,string:dword

local	old_esi:dword
local	old_edi:dword
	mov	old_esi,esi
	mov	old_edi,edi
	mov	edi,ecx
	mov	esi,edx
@@:	invoke	fgets,esi,255,edi;gets a string of 255 chars max from filein
	cmp	byte ptr [rsi],"/"
	jz	@b
	cmp	byte ptr [rsi],10
	jz	@b;until end of line is reached
	mov	esi,old_esi
	mov	edi,old_edi
	leave
	retn
readstr endp
;---------------------------------------------------------------------------
hDC	dq	?
hRC	dq	?
PixFrm	label	PIXELFORMATDESCRIPTOR 
	nSize             dw	sizeof PIXELFORMATDESCRIPTOR
  	nVersion          dw	1
  	dwFlags           dd	PFD_SUPPORT_OPENGL or PFD_DOUBLEBUFFER or PFD_DRAW_TO_WINDOW
  	iPixelType        db	PFD_TYPE_RGBA
  	cColorBits        db	32;Select Our Color Depth
  	cRedBits          db	0
  	cRedShift         db	0
  	cGreenBits        db	0
  	cGreenShift       db	0
  	cBlueBits         db	0
  	cBlueShift        db	0;Color Bits Ignored
  	cAlphaBits        db	0;No Alpha Buffer
  	cAlphaShift       db	0;Shift Bit Ignored
  	cAccumBits        db	0;No Accumulation Buffer
  	cAccumRedBits     db	0
  	cAccumGreenBits   db	0
  	cAccumBlueBits    db	0
  	cAccumAlphaBits   db	0;Accumulation Bits Ignored
  	cDepthBits        db	16;16Bit Z-Buffer (Depth Buffer)
  	cStencilBits      db	0;No Stencil Buffer
  	cAuxBuffers       db	0;No Auxiliary Buffer
  	iLayerType        db	PFD_MAIN_PLANE;Main Drawing Layer
  	bReserved         db	0;Reserved
  	dwLayerMask       dd	0
  	dwVisibleMask     dd	0
  	dwDamageMask      dd	0;Layer Masks Ignored

szClassName	db "NeHe lesson#25: Morphing Points Tutorial",0
FileName	db "br_Rabbit3.cur",0
spheretxt	db "sphere.txt",0; Load The First Object Into morph1 From File sphere.txt
torustxt	db "torus.txt",0; Load The Second Object Into morph2 From File torus.txt
tubetxt		db "tube.txt",0
; cx, cy  cz       
;(cx   , cy     cz      )
cx_		dd 0
cy		dd 0
cz		dd -15.0
; maxver      ,   
;  .      5 ,   20, 
;    15,   maxver      . 
; ,  maxver   20.
maxver		dd ?
;    (VERTEX).    morph{}  
; ,      . helper  
;     . *sour  
;  -,  *dest    ,    
;   (-).
morph1		OBJECT <>;    (morph1, 2, 3  4)
morph2		OBJECT <>
morph3		OBJECT <>
morph4		OBJECT <>
helper		OBJECT <>
morph0		dd offset morph1,offset morph2,offset morph3,offset morph4
;  . 
dest		dd offset morph1;destination -  
sour		dd offset morph1;source -  
; key    ,    ,   
;        .     
;    ,      ,  
;   
key		db 3
; morph    ,     
;     .     TRUE,    
;       .
morph		db FALSE
;step   -,      
;steps.      steps,     
; ,      .   
; step   steps,  ,   .
step		db 0
steps		db 200;  
aVerticesD	db "Vertices: %d",10,0
aFFF		db "%f %f %f",0
aRt		db "rt",0
;-----------------------------
;float
const0_001 	dd 0.001
const0_01 	dd 0.01
const0_5	dd 0.5
const1		dd 1.0
const7		dd 7.0
;double
constd0_1	dq 0.1
constd45	dq 45.0
constd100	dq 100.0
align 16
rot	dd 0,0,0,0;X and Y Rotation
speed	dd 0,0,0,0;X and Y Rotation Speed
end